<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/modifyprop_ser.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>modifyprop_ser.c</h1><a href="modifyprop__ser_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: modifyprop_ser.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a><a class="code" href="modifyprop__ser_8c.html#a155bbdd0e9cc1c9194b91b08ca8162ac">00031</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a155bbdd0e9cc1c9194b91b08ca8162ac">ModifyPropSer</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keywordtype">int</span> rank,size;
<a name="l00036"></a>00036   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00037"></a>00037   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="keywordflow">if</span> (rank) {
<a name="l00040"></a>00040     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00041"></a>00041   }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   PetscTruth flg;
<a name="l00044"></a>00044   <span class="keywordtype">int</span> nsliceprop;
<a name="l00045"></a>00045   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-nslicepropser&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nsliceprop,&amp;flg);CHKERRQ(ierr);
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00047"></a>00047     <span class="comment">/* set default values if option is missing */</span>
<a name="l00048"></a>00048     nsliceprop=0;
<a name="l00049"></a>00049     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00050"></a>00050       <span class="stringliteral">&quot;Option -nslicepropser not found, using default value %i!\n&quot;</span>,
<a name="l00051"></a>00051       nsliceprop
<a name="l00052"></a>00052     );
<a name="l00053"></a>00053   }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <span class="comment">/* exit if there is nothing to modify */</span>
<a name="l00056"></a>00056   <span class="keywordflow">if</span> (nsliceprop&lt;=0) {
<a name="l00057"></a>00057     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00058"></a>00058       <span class="stringliteral">&quot;nslicepropser==%i, nothing modified!\n&quot;</span>,
<a name="l00059"></a>00059       nsliceprop
<a name="l00060"></a>00060     );
<a name="l00061"></a>00061     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00062"></a>00062   }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="keywordtype">int</span> *ia,*ja;
<a name="l00066"></a>00066   ierr = <a class="code" href="mesh2dual_8c.html#a072403ed5e4bbd16fd845d52009d1270">Mesh2Dual</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="keywordtype">int</span> *elebnd;
<a name="l00069"></a>00069   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;elebnd);CHKERRQ(ierr);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">/* mark element if a whole face is on the boundary */</span>
<a name="l00072"></a>00072   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00073"></a>00073     elebnd[i]=<a class="code" href="griddata_8h.html#af23ac2ffd709eb569a1f0c98d06be299">C_INT</a>;
<a name="l00074"></a>00074     <span class="comment">/* get number of neighbours for current element */</span>
<a name="l00075"></a>00075     <span class="keywordtype">int</span> t_nnb;
<a name="l00076"></a>00076     t_nnb=ia[i+1]-ia[i];
<a name="l00077"></a>00077     <span class="keywordflow">if</span> (t_nnb&lt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) {
<a name="l00078"></a>00078       elebnd[i]=<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a>;
<a name="l00079"></a>00079     }
<a name="l00080"></a>00080   }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">/* mark element if at least a node is on the boundary */</span>
<a name="l00083"></a>00083 <span class="comment">/*</span>
<a name="l00084"></a>00084 <span class="comment">  for (int i=0;i&lt;gdata-&gt;n_ele;i++) {</span>
<a name="l00085"></a>00085 <span class="comment">    elebnd[i]=C_INT;</span>
<a name="l00086"></a>00086 <span class="comment">    for (int j=0;j&lt;NV;j++) {</span>
<a name="l00087"></a>00087 <span class="comment">      if (gdata-&gt;vertbndg2bnd[gdata-&gt;elevert[i*NV+j]]&gt;=0) {</span>
<a name="l00088"></a>00088 <span class="comment">        if (elebnd[i]!=C_BND) {</span>
<a name="l00089"></a>00089 <span class="comment">          elebnd[i]=C_BND;</span>
<a name="l00090"></a>00090 <span class="comment">        }</span>
<a name="l00091"></a>00091 <span class="comment">      }</span>
<a name="l00092"></a>00092 <span class="comment">    }</span>
<a name="l00093"></a>00093 <span class="comment">  }</span>
<a name="l00094"></a>00094 <span class="comment">*/</span>
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">/* allocate array of new property ids */</span>
<a name="l00097"></a>00097   <span class="keywordtype">int</span> *newpid;
<a name="l00098"></a>00098   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;newpid);CHKERRQ(ierr);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="keywordtype">int</span> cnt1;
<a name="l00101"></a>00101   cnt1=0;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">/* elements on surface get new (highest) property id */</span>
<a name="l00104"></a>00104   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00105"></a>00105     <span class="keywordflow">if</span> (elebnd[i]==<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a>) {
<a name="l00106"></a>00106 <span class="comment">/*</span>
<a name="l00107"></a>00107 <span class="comment">      newpid[i]=gdata-&gt;eleprop[i]+gdata-&gt;n_prop;</span>
<a name="l00108"></a>00108 <span class="comment">      cnt1++;</span>
<a name="l00109"></a>00109 <span class="comment">*/</span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111       <span class="comment">/* special case: bottom surface */</span>
<a name="l00112"></a>00112       <span class="keywordflow">if</span> (
<a name="l00113"></a>00113         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+0]+2]+
<a name="l00114"></a>00114         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+1]+2]+
<a name="l00115"></a>00115         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+2]+2]+
<a name="l00116"></a>00116         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+3]+2]&lt;3
<a name="l00117"></a>00117       ) {
<a name="l00118"></a>00118         newpid[i]=2*gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;
<a name="l00119"></a>00119         cnt1++;
<a name="l00120"></a>00120       }
<a name="l00121"></a>00121       <span class="comment">/* special case: top surface */</span>
<a name="l00122"></a>00122       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (
<a name="l00123"></a>00123         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+0]+2]+
<a name="l00124"></a>00124         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+1]+2]+
<a name="l00125"></a>00125         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+2]+2]+
<a name="l00126"></a>00126         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+3]+2]&gt;77
<a name="l00127"></a>00127       ) {
<a name="l00128"></a>00128         newpid[i]=2*gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>+1;
<a name="l00129"></a>00129         cnt1++;
<a name="l00130"></a>00130       }
<a name="l00131"></a>00131       <span class="comment">/* assign new property id to other surface elements */</span>
<a name="l00132"></a>00132       <span class="keywordflow">else</span> {
<a name="l00133"></a>00133         newpid[i]=gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;
<a name="l00134"></a>00134         cnt1++;
<a name="l00135"></a>00135       }
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137     <span class="keywordflow">else</span> {
<a name="l00138"></a>00138       <span class="comment">/* retain old property id */</span>
<a name="l00139"></a>00139       newpid[i]=gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i];
<a name="l00140"></a>00140     }
<a name="l00141"></a>00141   }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">/* modify property id of selected elements */</span>
<a name="l00144"></a>00144   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00145"></a>00145     <span class="keywordflow">if</span> (newpid[i]&gt;=gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>) {
<a name="l00146"></a>00146       gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]=newpid[i];
<a name="l00147"></a>00147       newpid[i]=<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>;
<a name="l00148"></a>00148     }
<a name="l00149"></a>00149   }
<a name="l00150"></a>00150   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00151"></a>00151     <span class="stringliteral">&quot;Modified property id of %i surface elements\n&quot;</span>,
<a name="l00152"></a>00152     cnt1
<a name="l00153"></a>00153   );
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordtype">int</span> cnt2;
<a name="l00157"></a>00157   cnt2=0;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">/* propagate new property ids into the interior */</span>
<a name="l00160"></a>00160   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=1;j&lt;nsliceprop;j++) {
<a name="l00161"></a>00161     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00162"></a>00162       <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]&gt;=gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>) {
<a name="l00163"></a>00163         <span class="comment">/* get number of neighbours for current element */</span>
<a name="l00164"></a>00164         <span class="keywordtype">int</span> t_nnb;
<a name="l00165"></a>00165         t_nnb=ia[i+1]-ia[i];
<a name="l00166"></a>00166 
<a name="l00167"></a>00167         <span class="comment">/* loop all neighbours */</span>
<a name="l00168"></a>00168         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;t_nnb;k++) {
<a name="l00169"></a>00169           <span class="comment">/* get the id of our neighbour */</span>
<a name="l00170"></a>00170           <span class="keywordtype">int</span> t_nbid;
<a name="l00171"></a>00171           t_nbid=ja[ia[i]+k];
<a name="l00172"></a>00172 
<a name="l00173"></a>00173           <span class="comment">/* set new property id unless we do already have a new one! */</span>
<a name="l00174"></a>00174           <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[t_nbid]&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>) {
<a name="l00175"></a>00175             newpid[t_nbid]=gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i];
<a name="l00176"></a>00176           }
<a name="l00177"></a>00177         }
<a name="l00178"></a>00178       }
<a name="l00179"></a>00179     }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181     <span class="comment">/* modify property id of selected elements */</span>
<a name="l00182"></a>00182     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00183"></a>00183       <span class="keywordflow">if</span> (newpid[i]&gt;=gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>) {
<a name="l00184"></a>00184         gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]=newpid[i];
<a name="l00185"></a>00185         cnt2++;
<a name="l00186"></a>00186         newpid[i]=<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>;
<a name="l00187"></a>00187       }
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189   }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00192"></a>00192     <span class="stringliteral">&quot;Modified property id of %i additional elements\n&quot;</span>,
<a name="l00193"></a>00193     cnt2
<a name="l00194"></a>00194   );
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00197"></a>00197     <span class="stringliteral">&quot;Modified property id of %i elements in total\n&quot;</span>,
<a name="l00198"></a>00198     cnt1+cnt2
<a name="l00199"></a>00199   );
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   assert(cnt1+cnt2&lt;=gdata-&gt;n_ele);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="comment">/* update counter of property ids */</span>
<a name="l00205"></a>00205   gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a> = 2*gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>+2;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="comment">/* reread property ids */</span>
<a name="l00208"></a>00208   ierr = PetscFree(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>);CHKERRQ(ierr);
<a name="l00209"></a>00209   ierr = <a class="code" href="magpario_8h.html#a59544353738dfce0bdce48409d9b3c8b">ReadKrn</a>(gdata);CHKERRQ(ierr);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   ierr = PetscFree(newpid);CHKERRQ(ierr);
<a name="l00212"></a>00212   ierr = PetscFree(elebnd);CHKERRQ(ierr);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   ierr = PetscFree(ia);CHKERRQ(ierr);
<a name="l00215"></a>00215   ierr = PetscFree(ja);CHKERRQ(ierr);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00218"></a>00218 }
<a name="l00219"></a>00219 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

